<?php
// Pengaturan
$folder = 'bahan/'; // Nama folder
$templateFile = $folder . rand(1, 15) . '.html'; // Memilih nomor acak antara 1 dan 20, dan menggabungkannya dengan ekstensi .html
$sitemapFile ='sitemap.xml'; // Nama file sitemap
$robotsTxtFile ='robots.txt'; // Nama file robots.txt
$keywordFile = $folder . 'test.txt'; // Nama file keyword
$googleVerificationFile = $folder . 'googled5e1fea478e4e438.html'; // Nama file verifikasi Google

$generateSitemap = true; // Opsi untuk menghasilkan sitemap
$generateRobotsTxt = true; // Opsi untuk menghasilkan robots.txt
$generatePerFolder = false; // Opsi untuk menghasilkan sitemap dan robots.txt per folder atau hanya di direktori root
$generateGoogleVerification = false; // Opsi untuk menghasilkan file verifikasi Google
$enableParaphrase = false; // Opsi untuk mengaktifkan atau menonaktifkan parafrase

$outputFormat = 'html'; // Format output file: html atau php
$keepImageInRoot = false; // Menentukan apakah gambar akan tetap berada di root atau disalin ke folder

$gambarFormat = 'png'; // Format gambar
$formatRefferal = 'http://example.com/'; // Format refferal tanpa refferal hanya domain utama # domainrefferal.com/brand

// Daftar parafrase
$paraphrases = array(
    // ------------------------------------slot----------------------------------------------------------
);


function generateRandomFileName() {
    $characters = 'abcdefghijklmnopqrstuvwxyz0123456789';
    $randomString = '';
    $length = 10; // panjang nama file acak

    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, strlen($characters) - 1)];
    }

    return $randomString;
}

function paraphraseContent($content, $paraphrases) {
    $anchorPattern = '/<a\b([^>]*)>(.*?)<\/a>/i';

    // Menyimpan anchor yang ditemukan
    $anchors = [];
    preg_match_all($anchorPattern, $content, $anchors);

    foreach ($paraphrases as $keyword => $synonyms) {
        if (isset($synonyms) && is_array($synonyms) && count($synonyms) > 0) {
            $pattern = '/(?<!\w)' . $keyword . '(?!\w)/iu';
            $replacement = ucwords($synonyms[array_rand($synonyms)]);

            $content = preg_replace($pattern, $replacement, $content);
        }
    }

    // Mengubah anchor menjadi huruf kecil semua
    foreach ($anchors[0] as $i => $anchor) {
        $lowercaseAnchor = preg_replace_callback('/<a\b([^>]*)>/i', function ($matches) {
            $match = strtolower($matches[0]);
            return $match;
        }, $anchor);
        $content = str_replace($anchors[0][$i], $lowercaseAnchor, $content);
    }

    return $content;
}

function generateHTMLFile($keyword, $templateFile, $generatePerFolder, $generateRobotsTxt, $generateSitemap, $generateGoogleVerification, $robotsTxtFile, $sitemapFile, $googleVerificationFile, $outputFormat, $enableParaphrase, $paraphrases, $keepImageInRoot, $gambarFormat, $formatRefferal)
{
    $outputFolder = str_replace(' ', '-', $keyword);

    // Ubah keyword menjadi huruf kapital
    $title = ucwords($keyword);

    // Baca template file
    $templateContent = file_get_contents($templateFile);

    // Ambil direktori saat ini
    $currentURL = 'https://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);

    // Ganti #domain dengan direktori saat ini dan nama folder yang dibuat
    $templateContent = str_replace('#domain', $currentURL . '/' . $outputFolder . '/', $templateContent);

    // Replace variable #refferal dengan $formatRefferal
    if ($formatRefferal) {
        $templateContent = str_replace('#refferal', $formatRefferal . $keyword, $templateContent);
    }

// Ganti variabel $gambarBrand dengan nama keyword yang dibuat
if ($keepImageInRoot) {
    $gambarBrand = $currentURL . '/' . str_replace(' ', '-', $keyword) .'.'. $gambarFormat;
    $templateContent = str_replace('#gambar', $gambarBrand, $templateContent);

    // Salin file gambar brand ke direktori root dan ubah namanya
    $gambarSource =  'default.png';
    $gambarDestination = str_replace(' ', '-', $keyword) .'.'. $gambarFormat;

    // Periksa apakah file gambar default.png ada sebelum menyalin dan mengubah namanya
    if (file_exists($gambarSource)) {
        $gambarCopyResult = copy($gambarSource, $gambarDestination);

        if ($gambarCopyResult) {
            echo 'File gambar brand default berhasil disalin dan diubah nama menjadi: ' . $gambarDestination;
        } else {
            echo 'Gagal menyalin dan mengubah nama file gambar brand default.';
        }
    } else {
        echo 'File gambar brand default tidak ditemukan.';
    }
} elseif (!$keepImageInRoot) {
    $gambarBrand = $currentURL . '/' . $outputFolder . '/' . str_replace(' ', '-', $keyword) .'.'. $gambarFormat;
    $gambarPath = $outputFolder . '/' . str_replace(' ', '-', $keyword) .'.'. $gambarFormat;
    $templateContent = str_replace('#gambar', $gambarBrand, $templateContent);

    // Salin file gambar brand ke folder yang sama dan ubah namanya
    $gambarSource =  'default.png';
    $gambarDestination = $gambarPath;

    // Periksa apakah file gambar default.png ada sebelum menyalin dan mengubah namanya
    if (file_exists($gambarSource)) {
        $gambarCopyResult = copy($gambarSource, $gambarDestination);

        if ($gambarCopyResult) {
            echo 'File gambar brand default berhasil disalin ke: ' . $gambarDestination;
        } else {
            echo 'Gagal menyalin file gambar brand default.';
        }
    } else {
        echo 'File gambar brand default tidak ditemukan.';
    }
}



    // Gunakan URL gambar brand atau gambar default dalam konten template
    // $templateContent = str_replace('gambar_brand', $gambarBrand, $templateContent);
    
    // Daftar judul dengan penggunaan variabel $title yang telah diubah
    $judulList = [
        "{$title}: Situs Judi Slot Gacor Terbaik & Daftar IDN Slot Online Terpercaya",
        "Daftar Link Situs {$title} Terpercaya Gampang Menang",
        "{$title}: Situs Slot Gacor Hari Ini Gampang Menang Maxwin",
        "10 Situs Daftar {$title} Dan Link Alternatif Situs Slot Gacor Terbaru",
        "15 Situs Daftar {$title} Dan Link Alternatif Situs Slot Gacor Terbaru",
        "20 Situs Daftar {$title} Dan Link Alternatif Situs Slot Gacor Terbaru",
        "12 Situs Daftar {$title} Dan Link Alternatif Situs Slot Gacor Terbaru",
        "{$title}: Situs Judi Slot Online Gacor Terbaru Gampang Menang Maxwin 2023",
        "{$title}: Daftar Situs Slot Online Gacor Gampang Menang Maxwin Terbaru",
        "{$title} : Daftar Situs Judi Online Slot Gacor Terlengkap Dan Resmi Terpercaya 2023",
        "{$title} : Daftar Judi Slot Online Gacor Gampang Menang Terbaru dan Terpercaya 2023",
        "SLOT GACOR HARI INI: Daftar Situs {$title} Online Terpercaya",
        "{$title} - Link Situs Slot Gacor Gampang Menang Terbaru",
        "{$title} : Situs Slot 4D Online Terpercaya Mudah Menang",
        "{$title} : Bandar Slot Deposit 5000 Paling Aman dan Terpercaya 2023",
        "{$title} : Situs Judi Slot Gacor Deposit Slot 5000 Terpercaya Mudah Maxwin 2023",
        "{$title}: Situs Link Slot Super Gacor Server Thailand Terbaru",
        "{$title}: Situs Link Slot Super Gacor Server Luar Negeri Terbaru",
        "{$title}: Situs Link Slot Super Gacor Server Kamboja Terbaru",
        "{$title}: Situs Link Slot Super Gacor Server Amerika Terbaru",
        "{$title}: Situs Link Slot Super Gacor Server Jepang Terbaru",
        "{$title}: Situs Link Slot Super Gacor Server Busan Terbaru",
        "{$title}: Situs Link Slot Super Gacor Server Singapura Terbaru",
        "Daftar Situs Slot Online Gacor Tanpa Potongan Bonus New Member 100%",
        "5 Daftar Bocoran Game Slot Gacor RTP Tertinggi Gampang Menang Hari Ini",
        "Daftar Link Situs Slot Gacor Terbaik dan Terpercaya 2023 {$title}"
    ];
    
    $randomJudul = $judulList[array_rand($judulList)];
    
    // Ganti #judul dengan judul acak yang dihasilkan
    $templateContent = str_replace('#judul', $randomJudul, $templateContent);
    
    // Ganti #kw dengan keyword yang telah diubah menjadi huruf kapital
    $templateContent = str_replace('#kw', $title, $templateContent);
    
    // Lakukan hal-hal lain yang diperlukan...


    // Spin isi dalam tag <p>, <h1>, dan <h2> jika opsi enableParaphrase diaktifkan
    if ($enableParaphrase) {
        $templateContent = paraphraseContent($templateContent, $paraphrases);
    }

    // Mengubah anchor dan canonical menjadi huruf kecil
    $templateContent = preg_replace_callback('/<(a|canonical)\b([^>]*)>/i', function ($matches) {
        return '<' . strtolower($matches[1]) . $matches[2] . '>';
    }, $templateContent);

    // Buat folder jika belum ada
    if (!file_exists($outputFolder)) {
        mkdir($outputFolder);
    }

    // Tulis konten template ke file index.html atau index.php dalam folder
    $outputFile = $outputFolder . '/index.' . $outputFormat;

    file_put_contents($outputFile, $templateContent);
    echo 'Folder dan file berhasil dibuat: ' . $outputFile;

    // Generate robots.txt dan sitemap.xml di dalam folder jika opsi generatePerFolder diaktifkan
    if ($generatePerFolder) {
        // Generate robots.txt
        if ($generateRobotsTxt) {
            $robotsTxtContent = "User-agent: *" . PHP_EOL;
            $robotsTxtContent .= "Allow: /" . PHP_EOL;
            $robotsTxtContent .= "Sitemap: " . $currentURL . '/' . $outputFolder . '/' . $sitemapFile . PHP_EOL;

            file_put_contents($outputFolder . '/robots.txt', $robotsTxtContent);
            echo 'File robots.txt berhasil dibuat: ' . $outputFolder . '/robots.txt';
        }

        // Generate sitemap.xml
        if ($generateSitemap) {
            
            $sitemapContent = '<?xml version="1.0" encoding="UTF-8"?>' . PHP_EOL;
            $sitemapContent .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . PHP_EOL;

            $currentURL1 = "https://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
            $outputFolder1 = str_replace(' ', '-', $keyword);
            $sitemapContent .= "\t<url>" . PHP_EOL;
            $sitemapContent .= "\t\t<loc>" . $currentURL1 . '/' . $outputFolder1 . '/</loc>' . PHP_EOL;
            $sitemapContent .= "\t\t<lastmod>" . date("Y-m-d\TH:i:sP") . '</lastmod>' . PHP_EOL;
            $sitemapContent .= "\t\t<changefreq>daily</changefreq>" . PHP_EOL;
            $sitemapContent .= "\t\t<priority>1.0</priority>" . PHP_EOL;
            $sitemapContent .= "\t</url>" . PHP_EOL;


            $sitemapContent .= '</urlset>';

            file_put_contents($outputFolder . '/' . $sitemapFile, $sitemapContent);
            echo 'File sitemap.xml berhasil dibuat: ' . $outputFolder . '/' . $sitemapFile;
        }

        // Copy file verifikasi Google jika opsi generateGoogleVerification diaktifkan
        if ($generateGoogleVerification) {
            copy($googleVerificationFile, $outputFolder . '/' . basename($googleVerificationFile));
            echo 'File verifikasi Google berhasil disalin: ' . $outputFolder . '/' . basename($googleVerificationFile);
        }

        // Copy file gambar brand jika generatePerFolder diaktifkan
        if ($keepImageInRoot) {
            copy($gambarBrand, $outputFolder . '/' . $gambarBrand);
            echo 'File gambar brand berhasil disalin ke folder: ' . $outputFolder . '/' . $gambarBrand;
        } else {
            copy($gambarBrand, $gambarBrand);
            echo 'File gambar brand berhasil disalin ke root: ' . $gambarBrand;
        }
    } else {
        // Copy file gambar brand ke root jika keepImageInRoot bernilai true
        if ($keepImageInRoot) {
            copy($gambarBrand, $gambarBrand);
            echo 'File gambar brand berhasil disalin ke root: ' . $gambarBrand;
        }
    }
}

// Baca file keyword.txt untuk mendapatkan daftar keyword
$keywords = [];

if (file_exists($keywordFile)) {
    $keywords = file($keywordFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
} else {
    echo 'File keyword.txt tidak ditemukan.';
    exit;
}

// Generate HTML file, robots.txt, dan sitemap.xml untuk setiap keyword
foreach ($keywords as $keyword) {
    generateHTMLFile($keyword, $templateFile, $generatePerFolder, $generateRobotsTxt, $generateSitemap, $generateGoogleVerification, $robotsTxtFile, $sitemapFile, $googleVerificationFile, $outputFormat, $enableParaphrase, $paraphrases, $keepImageInRoot, $gambarFormat, $formatRefferal);
}

// Generate sitemap.xml di direktori root jika opsi generatePerFolder adalah false
if ($generateSitemap && !$generatePerFolder) {
    $currentURL = "https://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
    $sitemapContent = '<?xml version="1.0" encoding="UTF-8"?>' . PHP_EOL;
    $sitemapContent .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . PHP_EOL;

    // Membaca keyword dan buat sitemap untuk setiap keyword
    foreach ($keywords as $keyword) {
        $folderName = str_replace(' ', '-', $keyword);
        $sitemapContent .= "\t<url>" . PHP_EOL;
        $sitemapContent .= "\t\t<loc>" . $currentURL . '/' . $folderName . '/</loc>' . PHP_EOL;
        $sitemapContent .= "\t\t<lastmod>" . date("Y-m-d\TH:i:sP") . '</lastmod>' . PHP_EOL;
        $sitemapContent .= "\t\t<changefreq>daily</changefreq>" . PHP_EOL;
        $sitemapContent .= "\t\t<priority>1.0</priority>" . PHP_EOL;
        $sitemapContent .= "\t</url>" . PHP_EOL;
    }

    $sitemapContent .= '</urlset>';

    file_put_contents($sitemapFile, $sitemapContent);
    echo 'File sitemap.xml berhasil dibuat di direktori root: ' . $sitemapFile;
}


    // Generate robots.txt di direktori root jika opsi generatePerFolder adalah false
    if ($generateRobotsTxt) {
        $robotsTxtContent = "User-agent: *" . PHP_EOL;
        $robotsTxtContent .= "Allow: /" . PHP_EOL;
        $robotsTxtContent .= "Sitemap: " . $currentURL . '/' . basename($sitemapFile) . PHP_EOL;

        file_put_contents($robotsTxtFile, $robotsTxtContent);
        echo 'File robots.txt berhasil diperbarui di direktori root: ' . $robotsTxtFile;
    }

    // Copy file verifikasi Google jika opsi generateGoogleVerification diaktifkan
    if ($generateGoogleVerification) {
        copy($googleVerificationFile, $outputFolder . '/' . basename($googleVerificationFile));
        echo 'File verifikasi Google berhasil disalin ke direktori root: ' . $outputFolder . '/' . basename($googleVerificationFile);
    }

?>